--- src/http/modules/ngx_http_limit_req_module.c.orig	2016-04-08 01:05:27.799784132 +0300
+++ src/http/modules/ngx_http_limit_req_module.c	2016-04-08 01:29:59.519686277 +0300
@@ -267,8 +267,8 @@
     }
 
     ngx_log_error(lrcf->delay_log_level, r->connection->log, 0,
-                  "delaying request, excess: %ui.%03ui, by zone \"%V\"",
-                  excess / 1000, excess % 1000, &limit->shm_zone->shm.name);
+                  "delaying request, excess: %ui.%03ui, by zone \"%V\", %ui ms",
+                  excess / 1000, excess % 1000, &limit->shm_zone->shm.name, (ngx_uint_t)delay);
 
     if (ngx_handle_read_event(r->connection->read, 0) != NGX_OK) {
         return NGX_HTTP_INTERNAL_SERVER_ERROR;
@@ -491,7 +491,7 @@
 
     excess = *ep;
 
-    if (excess == 0 || (*limit)->nodelay) {
+    if (excess == 0 || (*limit)->nodelay == 1 || (ngx_uint_t)excess < (*limit)->nodelay) {
         max_delay = 0;
 
     } else {
@@ -528,7 +528,7 @@
 
         ctx->node = NULL;
 
-        if (limits[n].nodelay) {
+        if (limits[n].nodelay == 1 || (ngx_uint_t)excess < limits[n].nodelay) {
             continue;
         }
 
@@ -902,8 +902,22 @@
             continue;
         }
 
-        if (ngx_strcmp(value[i].data, "nodelay") == 0) {
-            nodelay = 1;
+        if (ngx_strncmp(value[i].data, "nodelay", 7) == 0) {
+            if (value[i].len == 7) {
+                nodelay = 1;
+            } else if (value[i].data[7] == '=') {
+                nodelay = ngx_atoi(value[i].data + 8, value[i].len - 8);
+                if (nodelay <= 0) {
+                    ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+                                       "invalid nodelay rate \"%V\"", &value[i]);
+                    return NGX_CONF_ERROR;
+                }
+                nodelay *= 1000;
+            } else {
+                ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+                                   "invalid nodelay agrument \"%V\"", &value[i]);
+                return NGX_CONF_ERROR;
+            }
             continue;
         }
 
